Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 1859)
@@ -4,8 +4,9 @@
    !! Ocean fluxes   : domain averaged freshwater budget
    !!======================================================================
-   !! History :  8.2  !  01-02  (E. Durand)  Original code
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  06-08  (G. Madec)  Surface module
-   !!            9.2  !  09-07  (C. Talandier) emp mean s spread over erp area 
+   !! History :  OPA  !  2001-02  (E. Durand)  Original code
+   !!   NEMO     1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            3.0  !  2006-08  (G. Madec)  Surface module
+   !!            3.2  !  2009-07  (C. Talandier) emp mean s spread over erp area 
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) embedded sea-ice case
    !!----------------------------------------------------------------------
 
@@ -27,10 +28,10 @@
    PRIVATE
 
-   PUBLIC   sbc_fwb      ! routine called by step
-
-   REAL(wp) ::   a_fwb_b            ! annual domain averaged freshwater budget
-   REAL(wp) ::   a_fwb              ! for 2 year before (_b) and before year.
-   REAL(wp) ::   empold             ! empold to be suppressed
-   REAL(wp) ::   area               ! global mean ocean surface (interior domain)
+   PUBLIC   sbc_fwb    ! routine called by step
+
+   REAL(wp) ::   a_fwb_b   ! annual domain averaged freshwater budget
+   REAL(wp) ::   a_fwb     ! for 2 year before (_b) and before year.
+   REAL(wp) ::   empold    ! empold to be suppressed
+   REAL(wp) ::   area      ! global mean ocean surface (interior domain)
 
    REAL(wp), DIMENSION(jpi,jpj) ::   e1e2_i    ! area of the interior domain (e1t*e2t*tmask_i)
@@ -40,5 +41,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -57,5 +58,5 @@
       !!                =2 annual global mean corrected from previous year
       !!                =3 global mean of emp set to zero at each nn_fsbc time step
-      !!                   & spread out over erp area depending its sign
+      !!                   and spread out over erp area depending its sign
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
@@ -63,10 +64,10 @@
       INTEGER, INTENT( in ) ::   kn_fwb   ! ocean time-step index
       !!
-      INTEGER  ::   inum                  ! temporary logical unit
-      INTEGER  ::   ikty, iyear           ! 
-      REAL(wp) ::   z_emp, z_emp_nsrf, zsum_emp, zsum_erp       ! temporary scalars
-      REAL(wp) ::   zsurf_neg, zsurf_pos, zsurf_tospread
-      REAL(wp), DIMENSION(jpi,jpj) ::   ztmsk_neg, ztmsk_pos, ztmsk_tospread
-      REAL(wp), DIMENSION(jpi,jpj) ::   z_wgt, zerp_cor
+      INTEGER  ::   inum          ! temporary logical unit
+      INTEGER  ::   ikty, iyear   ! 
+      REAL(wp) ::   z_emp, z_emp_nsrf, zsum_emp, zsum_erp, zcoef     ! temporary scalars
+      REAL(wp) ::   zsurf_neg, zsurf_pos, zsurf_tospread             !    -         -
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztmsk_neg, ztmsk_tospread    ! 2D workspace
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztmsk_pos, z_wgt, zerp_cor   !  -      -
       !!----------------------------------------------------------------------
       !
@@ -83,5 +84,4 @@
             IF( kn_fwb == 3 .AND. nn_sssr /= 2 )   &
                &   CALL ctl_stop( 'The option nn_fwb = 3 must be associated to nn_sssr = 2 ' )
-            
          ENDIF
          !
@@ -99,12 +99,11 @@
          CALL ctl_stop( ctmp1 )
          !
-         
-      !
       CASE ( 1 )                               ! global mean emp set to zero
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
             z_emp = SUM( e1e2_i(:,:) * emp(:,:) ) / area
             IF( lk_mpp )   CALL  mpp_sum( z_emp    )   ! sum over the global domain
-            emp (:,:) = emp (:,:) - z_emp
-            emps(:,:) = emps(:,:) - z_emp
+            zcoef = z_emp * rcp
+            emp(:,:) = emp(:,:) - z_emp
+            qns(:,:) = qns(:,:) + zcoef * sst_m(:,:)
          ENDIF
          !
@@ -138,6 +137,7 @@
          ! correct the freshwater fluxes
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            emp (:,:) = emp (:,:) + empold
-            emps(:,:) = emps(:,:) + empold
+            zcoef = z_emp * rcp
+            emp(:,:) = emp (:,:) + empold
+            qns(:,:) = qns(:,:) - zcoef * sst_m(:,:)
          ENDIF
          !
@@ -152,26 +152,24 @@
          !
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            ! Select <0 and >0 area of erp
+            !                                       ! Select <0 and >0 area of erp
             ztmsk_pos(:,:) = tmask_i(:,:)
-            WHERE( erp < 0.e0 ) ztmsk_pos = 0.e0
+            WHERE( erp(:,:) < 0.e0 )   ztmsk_pos(:,:) = 0.e0
             ztmsk_neg(:,:) = tmask_i(:,:) - ztmsk_pos(:,:)
 
-            ! Area filled by <0 and >0 erp 
-            zsurf_neg = SUM( e1e2_i(:,:)*ztmsk_neg(:,:) )
-            zsurf_pos = SUM( e1e2_i(:,:)*ztmsk_pos(:,:) )
+            !                                       ! Area filled by <0 and >0 erp 
+            zsurf_neg = SUM(  e1e2_i(:,:) * ztmsk_neg(:,:)  )
+            zsurf_pos = SUM(  e1e2_i(:,:) * ztmsk_pos(:,:)  )
         
-            ! emp global mean 
+            !                                       ! emp global mean 
             z_emp = SUM( e1e2_i(:,:) * emp(:,:) ) / area
             !
-            IF( lk_mpp )   CALL  mpp_sum( z_emp )
+            IF( lk_mpp )   CALL  mpp_sum( z_emp     )
             IF( lk_mpp )   CALL  mpp_sum( zsurf_neg )
             IF( lk_mpp )   CALL  mpp_sum( zsurf_pos )
             
-            IF( z_emp < 0.e0 ) THEN
-                ! to spread out over >0 erp area to increase evaporation damping process
+            IF( z_emp < 0.e0 ) THEN                 ! spread out over >0 erp area to increase evaporation damping process
                 zsurf_tospread = zsurf_pos
                 ztmsk_tospread(:,:) = ztmsk_pos(:,:)
-            ELSE
-                ! to spread out over <0 erp area to increase precipitation damping process
+            ELSE                                    ! spread out over <0 erp area to increase precipitation damping process
                 zsurf_tospread = zsurf_neg
                 ztmsk_tospread(:,:) = ztmsk_neg(:,:)
@@ -192,7 +190,7 @@
             CALL lbc_lnk( zerp_cor, 'T', 1. )
 
-            emp (:,:) = emp (:,:) + zerp_cor(:,:)
-            emps(:,:) = emps(:,:) + zerp_cor(:,:)
-            erp (:,:) = erp (:,:) + zerp_cor(:,:)
+            emp(:,:) = emp(:,:) + zerp_cor(:,:)
+            qns(:,:) = qns(:,:) - zerp_cor(:,:) * rcp * sst_m(:,:)
+            erp(:,:) = erp(:,:) + zerp_cor(:,:)
             
             IF( nprint == 1 .AND. lwp ) THEN
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 1859)
@@ -30,5 +30,5 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -72,9 +72,9 @@
          !             !   file    ! frequency !  variable  ! time intep !  clim  ! 'yearly' or ! weights  ! rotation   !
          !             !   name    !  (hours)  !   name     !   (T/F)    !  (T/F) !  'monthly'  ! filename ! pairs      ! 
-         sn_ice = FLD_N('ice_cover',    -1    ,  'ice_cov' ,  .true.    , .true. ,   'yearly'  , ''       , ''         )
-
-         REWIND ( numnam )               ! ... read in namlist namiif
+         sn_ice = FLD_N('ice_cover',    -1     ,  'ice_cov' ,  .true.    , .true. ,   'yearly'  , ''       , ''         )
+         !
+         REWIND ( numnam )               ! read in namlist namiif
          READ   ( numnam, namsbc_iif )
-
+         !
          ALLOCATE( sf_ice(1), STAT=ierror )
          IF( ierror > 0 ) THEN
@@ -83,13 +83,11 @@
          ALLOCATE( sf_ice(1)%fnow(jpi,jpj) )
          ALLOCATE( sf_ice(1)%fdta(jpi,jpj,2) )
-
-
-         ! fill sf_ice with sn_ice and control print
+         !
+         !                               ! fill sf_ice with sn_ice and control print
          CALL fld_fill( sf_ice, (/ sn_ice /), cn_dir, 'sbc_ice_if', 'ice-if sea-ice model', 'namsbc_iif' )
          !
       ENDIF
 
-      CALL fld_read( kt, nn_fsbc, sf_ice )           ! Read input fields and provides the
-      !                                              ! input fields at the current time-step
+      CALL fld_read( kt, nn_fsbc, sf_ice )           ! Read input fields at the current time-step
       
       IF( MOD( kt-1, nn_fsbc) == 0 ) THEN
@@ -101,7 +99,6 @@
          fr_i(:,:) = tfreez( sss_m ) * tmask(:,:,1)      ! sea surface freezing temperature [Celcius]
 
-         ! Flux and ice fraction computation
 !CDIR COLLAPSE
-         DO jj = 1, jpj
+         DO jj = 1, jpj          ! Flux and ice fraction computation
             DO ji = 1, jpi
                !
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 1859)
@@ -4,6 +4,7 @@
    !! Surface module :  provide to the ocean its surface boundary condition
    !!======================================================================
-   !! History :  3.0   !  07-2006  (G. Madec)  Original code
-   !!             -    !  08-2008  (S. Masson, E. .... ) coupled interface
+   !! History :  3.0  !  2007-06  (G. Madec)  Original code
+   !!            3.1  !  2008-08  (S. Masson, E. .... ) coupled interface
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -49,5 +50,5 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -86,5 +87,5 @@
 !!gm  IF( lk_sbc_cpl       ) THEN   ;   ln_cpl      = .TRUE.   ;   ELSE   ;   ln_cpl      = .FALSE.   ;   ENDIF
 
-      IF ( Agrif_Root() ) THEN
+      IF( Agrif_Root() ) THEN
         IF( lk_lim2 )            nn_ice      = 2
         IF( lk_lim3 )            nn_ice      = 3
@@ -123,4 +124,7 @@
       ENDIF
       IF( nn_ice == 0  )   fr_i(:,:) = 0.e0        ! no ice in the domain, ice fraction is always zero
+
+      emps(:,:) = 0.e0                             ! the salt flux will be computed (i.e. will be non-zero) only if 
+      !                                            ! sea-ice is present, or lk_vvl=F, or surface salt restoring is used.
 
       !                                            ! restartability   
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 1859)
@@ -8,4 +8,5 @@
    !!            3.0  !  2006-07  (G. Madec)  Surface module 
    !!            3.2  !  2009-04  (B. Lemaire)  Introduce iom_put
+   !!             -   !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -41,8 +42,9 @@
    REAL(wp), PUBLIC, DIMENSION(jpk)     ::   rnfmsk_z    !: river mouth mask (vert.)
 
+   REAL(wp) ::   rfact_rcp   ! = rn_rfact * rcp
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf   ! structure of input SST (file information, fields read)
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -64,5 +66,5 @@
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt          ! ocean time step
-      !!
+      !
       INTEGER  ::   ji, jj   ! dummy loop indices
       INTEGER  ::   ierror   ! temporary integer
@@ -78,5 +80,7 @@
             ALLOCATE( sf_rnf(1)%fdta(jpi,jpj,2) )
          ENDIF
-         CALL sbc_rnf_init(sf_rnf)
+         CALL sbc_rnf_init( sf_rnf )
+         !
+         rfact_rcp = rn_rfact * rcp
       ENDIF
 
@@ -85,11 +89,9 @@
          !                                                !-------------------!
          !
-         CALL fld_read( kt, nn_fsbc, sf_rnf )   ! Read Runoffs data and provides it
-         !                                      ! at the current time-step
-
-         ! Runoff reduction only associated to the ORCA2_LIM configuration
-         ! when reading the NetCDF file runoff_1m_nomask.nc
-         IF( cp_cfg == 'orca' .AND. jp_cfg == 2 )   THEN
-            DO jj = 1, jpj
+         CALL fld_read( kt, nn_fsbc, sf_rnf )                    ! Read Runoffs data at the current time-step
+         !
+!!gm CAUTION this is ugly  ===>>> to be removed!
+         IF( cp_cfg == 'orca' .AND. jp_cfg == 2 )   THEN         ! Runoff reduction only associated to the ORCA2_LIM configuration
+            DO jj = 1, jpj                                       ! when reading the NetCDF file runoff_1m_nomask.nc
                DO ji = 1, jpi
                   IF( gphit(ji,jj) > 40 .AND. gphit(ji,jj) < 65 )   sf_rnf(1)%fnow(ji,jj) = 0.85 * sf_rnf(1)%fnow(ji,jj)
@@ -97,10 +99,9 @@
             END DO
          ENDIF
-
-         ! C a u t i o n : runoff is negative and in kg/m2/s 
-
-         IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
-            emp (:,:) = emp (:,:) - rn_rfact * ABS( sf_rnf(1)%fnow(:,:) )
-            emps(:,:) = emps(:,:) - rn_rfact * ABS( sf_rnf(1)%fnow(:,:) )
+         !
+         IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN                    ! C a u t i o n : runoff is negative and in kg/m2/s 
+            emp(:,:) = emp(:,:) - rn_rfact  * ABS( sf_rnf(1)%fnow(:,:) )                ! mass flux
+            qns(:,:) = qns(:,:) + rfact_rcp * ABS( sf_rnf(1)%fnow(:,:) ) * sst_m(:,:)   ! its associated heat content (at SST)
+            !
             CALL iom_put( "runoffs", sf_rnf(1)%fnow )         ! runoffs
          ENDIF
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 1859)
@@ -6,4 +6,6 @@
    !! History :  3.0  !  2006-06  (G. Madec)  Original code
    !!            3.2  !  2009-04  (B. Lemaire)  Introduce iom_put
+   !!             -   !  2009-07  (C. Talandier, G. Madec)  Add a bound to the Erp 
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -37,5 +39,5 @@
    REAL(wp)        ::   rn_deds     = -27.70    ! restoring factor on SST and SSS
    LOGICAL         ::   ln_sssr_bnd = .false.   ! flag to bound erp term 
-   REAL(wp)        ::   rn_sssr_bnd =   0.e0    ! ABS(Max./Min.) value of erp term [mm/day]
+   REAL(wp)        ::   rn_sssr_bnd =   4.e0    ! ABS(Max./Min.) value of erp term [mm/day]
 
    REAL(wp) , ALLOCATABLE, DIMENSION(:) ::   buffer   ! Temporary buffer for exchange
@@ -46,5 +48,5 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -70,11 +72,8 @@
       !!
       INTEGER  ::   ji, jj   ! dummy loop indices
-      REAL(wp) ::   zerp     ! local scalar for evaporation damping
-      REAL(wp) ::   zqrp     ! local scalar for heat flux damping
-      REAL(wp) ::   zsrp     ! local scalar for unit conversion of rn_deds factor
-      REAL(wp) ::   zerp_bnd ! local scalar for unit conversion of rn_epr_max factor
       INTEGER  ::   ierror   ! return error code
-      !!
-      CHARACTER(len=100) ::  cn_dir          ! Root directory for location of ssr files
+      REAL(wp) ::   zerp, zqrp, zsrp, zerp_bnd    ! local scalar
+      !!
+      CHARACTER(len=100) ::  cn_dir = './'   ! Root directory for location of ssr files
       TYPE(FLD_N) ::   sn_sst, sn_sss        ! informations about the fields to be read
       NAMELIST/namsbc_ssr/ cn_dir, nn_sstr, nn_sssr, rn_dqdt, rn_deds, sn_sst, sn_sss, ln_sssr_bnd, rn_sssr_bnd
@@ -85,5 +84,4 @@
          !                                            ! -------------------- !
          !                            !* set file information
-         cn_dir  = './'            ! directory in which the model is executed
          ! ... default values (NB: frequency positive => hours, negative => months)
          !            !   file    ! frequency !  variable  ! time intep !  clim   ! 'yearly' or ! weights  ! rotation   !
@@ -158,8 +156,8 @@
                   END DO
                END DO
-               CALL iom_put( "qrp", qrp )                             ! heat flux damping
-            ENDIF
-            !
-            IF( nn_sssr == 1 ) THEN                   !* Salinity damping term (salt flux, emps only)
+               CALL iom_put( "qrp", qrp )                             ! heat flux damping 
+            ENDIF
+            !
+            IF( nn_sssr == 1 ) THEN                   !* Salinity damping term (salt flux only (emps))
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
 !CDIR COLLAPSE
@@ -167,13 +165,12 @@
                   DO ji = 1, jpi
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
-                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                        &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj) )
                      emps(ji,jj) = emps(ji,jj) + zerp
-                     erp( ji,jj) = zerp
+                     erp( ji,jj) = zerp / MAX( sss_m(ji,jj), 1.e-20  )  ! converted into an equivalent emp (diag. only)
                   END DO
                END DO
                CALL iom_put( "erp", erp )                             ! freshwater flux damping
                !
-            ELSEIF( nn_sssr == 2 ) THEN               !* Salinity damping term (volume flux, emp and emps)
+            ELSEIF( nn_sssr == 2 ) THEN               !* Salinity damping term (volume flux (emp) and qns)
                zsrp = rn_deds / rday                                  ! from [mm/day] to [kg/m2/s]
                zerp_bnd = rn_sssr_bnd / rday                          !       -              -    
@@ -183,9 +180,10 @@
                      zerp = zsrp * ( 1. - 2.*rnfmsk(ji,jj) )   &      ! No damping in vicinity of river mouths
                         &        * ( sss_m(ji,jj) - sf_sss(1)%fnow(ji,jj) )   &
-                        &        / ( sss_m(ji,jj) + 1.e-20   )
+                        &        / MAX(  sss_m(ji,jj), 1.e-20  )
                      IF( ln_sssr_bnd )   zerp = SIGN( 1., zerp ) * MIN( zerp_bnd, ABS(zerp) )
-                     emp (ji,jj) = emp (ji,jj) + zerp
-                     emps(ji,jj) = emps(ji,jj) + zerp
-                     erp (ji,jj) = zerp
+!!gm better coding   IF( ln_sssr_bnd )   zerp = MAX( -zerp_bnd, MIN( zerp, zerp_bnd )  )
+                     emp(ji,jj) = emp(ji,jj) + zerp
+                     qns(ji,jj) = qns(ji,jj) - zerp * rcp * sst_m(ji,jj)
+                     erp(ji,jj) = zerp
                   END DO
                END DO
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 1859)
@@ -1,10 +1,11 @@
 MODULE trasbc
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE  trasbc  ***
    !! Ocean active tracers:  surface boundary condition
-   !!==============================================================================
-   !! History :  8.2  !  98-10  (G. Madec, G. Roullet, M. Imbard)  Original code
-   !!            8.2  !  01-02  (D. Ludicone)  sea ice and free surface
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
+   !!======================================================================
+   !! History :  OPA  !  1998-10  (G. Madec, G. Roullet, M. Imbard)  Original code
+   !!            8.2  !  2001-02  (D. Ludicone)  sea ice and free surface
+   !!  NEMO      1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            3.3  !  2010-05  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -31,5 +32,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -52,4 +53,6 @@
       !!         at the surface by evaporation, precipitations and runoff (E-P-R); 
       !!      (3) Fwe, tracer carried with the water that is exchanged. 
+      !!            - salinity    : salt flux only due to freezing/melting
+      !!            sa = sa +  fsalt / rau0 / e3t  for k=1
       !!
       !!      Fext, flux through the air-sea interface for temperature and salt: 
@@ -76,9 +79,11 @@
       !!            (Tp P - Te E) + SST (P-E) = 0 when Tp=Te=SST
       !!            - salinity    : evaporation, precipitation and runoff
-      !!         water has a zero salinity (Fwe=0), thus only Fwi remains:
-      !!            sa = sa + emp * sn / e3t   for k=1
+      !!         water has a zero salinity  but there is a salt flux due to 
+      !!         freezing/melting, thus:
+      !!            sa = sa + emp * sn / rau0 / e3t   for k=1
+      !!                    + fsalt    / rau0 / e3t
       !!         where emp, the surface freshwater budget (evaporation minus
       !!         precipitation minus runoff) given in kg/m2/s is divided
-      !!         by 1035 kg/m3 (density of ocena water) to obtain m/s.    
+      !!         by rau0 = 1020 kg/m3 (density of sea water) to obtain m/s.    
       !!         Note: even though Fwe does not appear explicitly for 
       !!         temperature in this routine, the heat carried by the water
@@ -92,5 +97,5 @@
       !!         deal with it in this routine.
       !!           - temperature: Fwe=SST (P-E+R) is added to Fext.
-      !!           - salinity:  Fwe = 0, there is no surface flux of salt.
+      !!           - salinity:  Fwe sa = sa +  fsalt / rau0 / e3t.
       !!
       !! ** Action  : - Update the 1st level of (ta,sa) with the trend associated
@@ -103,6 +108,6 @@
       INTEGER, INTENT(in) ::   kt     ! ocean time-step index
       !!
-      INTEGER  ::   ji, jj                   ! dummy loop indices
-      REAL(wp) ::   zta, zsa, zsrau, zse3t   ! temporary scalars
+      INTEGER  ::   ji, jj        ! dummy loop indices
+      REAL(wp) ::   z1_e3t_rau0   ! local scalars
       !!----------------------------------------------------------------------
 
@@ -113,9 +118,4 @@
       ENDIF
 
-      zsrau = 1. / rau0             ! initialization
-#if defined key_zco
-      zse3t = 1. / e3t_0(1)
-#endif
-
       IF( l_trdtra ) THEN           ! Save ta and sa trends
          ztrdt(:,:,:) = ta(:,:,:) 
@@ -123,24 +123,29 @@
       ENDIF
 
+!!gm useless staff ???
       IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
+!!gm
 
-      ! Concentration dillution effect on (t,s)
-      DO jj = 2, jpj
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco
-            zse3t = 1. / fse3t(ji,jj,1)
-#endif
-            IF( lk_vvl) THEN
-               zta = r1_rau0_rcp * qns(ji,jj) * zse3t &              ! temperature : heat flux
-                &    - emp(ji,jj) * zsrau * tn(ji,jj,1)  * zse3t     ! & cooling/heating effet of EMP flux
-               zsa = 0.e0                                            ! No salinity concent./dilut. effect
-            ELSE
-               zta = r1_rau0_rcp * qns(ji,jj) * zse3t                ! temperature : heat flux
-               zsa = emps(ji,jj) * zsrau * sn(ji,jj,1)   * zse3t     ! salinity :  concent./dilut. effect
-            ENDIF
-            ta(ji,jj,1) = ta(ji,jj,1) + zta                          ! add the trend to the general tracer trend
-            sa(ji,jj,1) = sa(ji,jj,1) + zsa
+      
+      IF( lk_vvl ) THEN          ! Variable Volume Layers case   ===>> heat content of mass flux in qns
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               z1_e3t_rau0 = 1./ ( fse3t(ji,jj,1) * rau0 )
+               ta(ji,jj,1) = ta(ji,jj,1) + z1_e3t_rau0 * qns (ji,jj)  * r1_rcp             ! non solar heat flux
+               sa(ji,jj,1) = sa(ji,jj,1) + z1_e3t_rau0 * emps(ji,jj)                       ! salt flux (freezing/melting)
+            END DO
          END DO
-      END DO
+         !
+      ELSE                       ! Constant Volume layers case   ===>> Concentration dillution effect
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               z1_e3t_rau0 = 1./ ( fse3t(ji,jj,1) * rau0 )
+               ta(ji,jj,1) = ta(ji,jj,1) + z1_e3t_rau0 * (  qns (ji,jj) * r1_rcp       &   ! non solar heat flux
+                  &                                       + emp (ji,jj) * tn(ji,jj,1)  )   ! concent./dilut. effect
+               sa(ji,jj,1) = sa(ji,jj,1) + z1_e3t_rau0 * (  emps(ji,jj)                &   ! salt flux (freezing/melting)
+                  &                                       + emp (ji,jj) * sn(ji,jj,1)  )   ! concent./dilut. effect
+            END DO
+         END DO
+      ENDIF
 
       IF( l_trdtra ) THEN      ! save the sbc trends for diagnostic
